<?php


namespace FiloBlu\Refilo\Model\Catalog\Product\Type;


use Magento\Catalog\Api\ProductRepositoryInterface;
use Magento\Catalog\Model\Product\Option;
use Magento\Catalog\Model\Product\Type;
use Magento\Eav\Model\Config;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Framework\Event\ManagerInterface;
use Magento\Framework\Filesystem;
use Magento\Framework\Locale\FormatInterface;
use Magento\Framework\Pricing\PriceCurrencyInterface;
use Magento\Framework\Registry;
use Magento\Framework\Serialize\Serializer\Json;
use Magento\MediaStorage\Helper\File\Storage\Database;
use Magento\Store\Model\StoreManagerInterface;
use Psr\Log\LoggerInterface;

class Giftcard extends \Magento\GiftCard\Model\Catalog\Product\Type\Giftcard
{

    public function __construct(Option $catalogProductOption,
                                Config $eavConfig,
                                Type $catalogProductType,
                                ManagerInterface $eventManager,
                                Database $fileStorageDb,
                                Filesystem $filesystem,
                                Registry $coreRegistry,
                                LoggerInterface $logger,
                                ProductRepositoryInterface $productRepository,
                                StoreManagerInterface $storeManager,
                                FormatInterface $localeFormat,
                                ScopeConfigInterface $scopeConfig,
                                PriceCurrencyInterface $priceCurrency,
                                Json $serializer = null)
    {
        parent::__construct($catalogProductOption,
            $eavConfig,
            $catalogProductType,
            $eventManager,
            $fileStorageDb,
            $filesystem,
            $coreRegistry,
            $logger,
            $productRepository,
            $storeManager,
            $localeFormat,
            $scopeConfig,
            $priceCurrency,
            $serializer);
    }

    protected function _getAllowedAmounts($product)
    {

        $productId = $product->getId();
        if (!isset($this->_giftcardAmounts[$productId])) {
            $allowedAmounts = [];
            foreach ($product->getGiftcardAmounts() as $value) {
                $allowedAmounts[] = $value['value'];
            }
            $this->_giftcardAmounts[$productId] = $allowedAmounts;
        }
        return $this->_giftcardAmounts[$productId];
    }

}
